From: "jim.meyer" <no-reply>
Date: Sun, 14 Jun 2020 19:02:11 -0500
Subject: Fixed unassigned variable error. Also don't both re-writing image file if it hasn't changed.

---
 piexif/_remove.py             | 56 +++++++++++++++++++----------------
 tests/images/not_an_image.txt |  1 +
 tests/s_test.py               |  8 +++++
 3 files changed, 39 insertions(+), 26 deletions(-)
 create mode 100644 tests/images/not_an_image.txt

--- a/piexif/_remove.py
+++ b/piexif/_remove.py
@@ -26,31 +26,35 @@ def remove(src, new_file=None):
             file_type = "jpeg"
         elif src_data[0:4] == b"RIFF" and src_data[8:12] == b"WEBP":
             file_type = "webp"
-
-    if file_type == "jpeg":
-        segments = split_into_segments(src_data)
-        exif = get_exif_seg(segments)
-        if exif:
-            new_data = src_data.replace(exif, b"")
         else:
-            new_data = src_data
-    elif file_type == "webp":
-        try:
-            new_data = _webp.remove(src_data)
-        except ValueError:
-            new_data = src_data
-        except e:
-            print(e.args)
-            raise ValueError("Error occurred.")
+            file_type = None
+
+    if file_type is not None:
+        if file_type == "jpeg":
+            segments = split_into_segments(src_data)
+            exif = get_exif_seg(segments)
+            if exif:
+                new_data = src_data.replace(exif, b"")
+            else:
+                new_data = src_data
+        elif file_type == "webp":
+            try:
+                new_data = _webp.remove(src_data)
+            except ValueError:
+                new_data = src_data
+            except e:
+                print(e.args)
+                raise ValueError("Error occurred.")
 
-    if isinstance(new_file, io.BytesIO):
-        new_file.write(new_data)
-        new_file.seek(0)
-    elif new_file:
-        with open(new_file, "wb+") as f:
-            f.write(new_data)
-    elif output_is_file:
-        with open(src, "wb+") as f:
-            f.write(new_data)
-    else:
-        raise ValueError("Give a second argument to 'remove' to output file")
\ No newline at end of file
+        if isinstance(new_file, io.BytesIO):
+            new_file.write(new_data)
+            new_file.seek(0)
+        elif new_file:
+            with open(new_file, "wb+") as f:
+                f.write(new_data)
+        elif output_is_file:
+            if new_data is not src_data:
+                with open(src, "wb+") as f:
+                    f.write(new_data)
+        else:
+            raise ValueError("Give a second argument to 'remove' to output file")
\ No newline at end of file
--- /dev/null
+++ b/tests/images/not_an_image.txt
@@ -0,0 +1 @@
+This tests _remove() handling of files that are not jpgs or webp
--- a/tests/s_test.py
+++ b/tests/s_test.py
@@ -1010,6 +1010,14 @@ class WebpTests(unittest.TestCase):
             piexif.remove(IMAGE_DIR + filename, OUT_DIR + "rr_" + filename)
             Image.open(OUT_DIR + "rr_" + filename)
 
+    def test_remove_unknown_image_type(self):
+        """Does remove ignore unknown image types?"""
+        IMAGE_DIR = "tests/images/"
+        OUT_DIR = "tests/images/out/"
+        filename = "not_an_image.txt"
+        piexif.remove(IMAGE_DIR + filename, OUT_DIR + "rr_" + filename)
+        self.assertFalse(os.path.isfile(OUT_DIR + "rr_" + filename))
+
     def test_insert(self):
         """Can PIL open WebP that is inserted exif?"""
         IMAGE_DIR = "tests/images/"
